install.packages("autoencoder")
library(autoencoder)

data(iris)
iris.x<-iris[,1:4]

set.seed(2018)

fit <- autoencode(as.matrix(iris.x),
                  nl=3,                 #   (Ʈ 3: Է, , )
                  N.hidden=2,          # г 
                  unit.type="logistic",   #  ȰԼ
                  rho=0.3,             # ڼ Ű 
                  lambda=1e-5,        # ġ  Ű
                  beta=1e-5,           # ڼ Ģ Ű
                  epsilon=0.1,   # Ժ κ  ߻Ͽ ġ ʱⰪ  
                  optim.method=c("BFGS"), #Լ ּҰ ã  ȭ  
                  rescale.flag=T       #ǥȭ Ǵ ôȭ  
)

pred <- predict(fit, as.matrix(iris.x), hidden.output = T)
new <- cbind(pred$X.output, iris[,5])
feature1 <- pred$X.output[,1]
feature2 <- pred$X.output[,2]

plot(feature1, feature2, col=new[,3], pch=new[,3])
legend("topleft", c("setosa", "versicolor","virginica"), col=1:3, pch=1:3)
