#=== darch ġ  darch  ===#
install.packages("devtools")
library(devtools)
install_github("maddin79/darch@v0.12.0")
library(darch)  

#=== AER Ű ִ CreditCard ڷ ó ===#
install.packages("AER")
library(AER)

data("CreditCard", package="AER")    
drops <- c("card","owner","selfemp","share")
num_vars <- CreditCard[, !(names(CreditCard) %in% drops)]  # ġ  

normalize <- function(x) {
  return ((x - min(x)) / (max(x) - min(x)))}    # ȭ Լ  
norm_num_vars <- as.data.frame(lapply(num_vars, normalize)) # ȭ 
share <- CreditCard$share
card <- factor(CreditCard$card)
owner <- factor(CreditCard$owner)   
selfemp <- factor(CreditCard$selfemp) 

data <- as.data.frame(cbind(card,owner,selfemp,norm_num_vars,share))

#=== Ʒڷ ڷ  ===#
set.seed(20180202) 
tr_ind <- sample(1:nrow(data), 1200, replace=F)
tr_data <- data[tr_ind,]
te_data <- data[-tr_ind,]
tr_data <- tr_data[,4:12]
te_data <- te_data[,4:12]

#===  Ͽ  Ű нϱ ===#
# darch RBM Ͽ н ϰ backpropagation Ǵ 
# rpropagation Ͽ Ѵ
darch_fit <- darch(share~., data=tr_data, rbm.numEpochs = 50,
                   rbm.batchSize = 2, rbm.lastLayer = F, 
                   layers = c(8,8,7,5,5,1), 
                   # Է, 1, 2, 3, 4      
                   darch.fineTuneFunction = rpropagation, rprop.method = "iRprop+",
                   darch.isClass = F,  #ȸͺм  ݵ ʿ
                   darch.batchSize = 2, retainData = F, darch.numEpochs = 100,
                   darch.unitFunction = linearUnit)

#=== н  Ű Ͽ ϱ ===#
y_pred <- predict(darch_fit, newdata=te_data[,1:8])
mean((y_pred - te_data[,9])^2)  #ڷῡ  MSE 
#[]
#0.5730008
